#!/usr/bin/python

import sys,os
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4 import uic
from webtv import webtv

import rmain # ressources

class MonAppli (QMainWindow):
   def __init__(self,*args):
      QWidget.__init__(self, *args)
      self.globalpath = os.path.dirname(os.path.abspath(__file__))
      uic.loadUi(os.path.join(self.globalpath,"main.ui"), self)
      for o in dir(self):
         # search for buttons chaineXX
         if o.startswith("chaine"):
            #~ print self.__dict__[o]
            # connect to go(buttonName)
            QObject.connect(self.__dict__[o], SIGNAL("clicked()"),lambda a=o: self.go(a))
      self.tv = webtv()
                    
   def go(self,btn):
      chaine = btn[-2:].lstrip("0")
      print "click",chaine
      self.tv.getSession()
      self.tv.setStream(chaine)
      url = self.tv.getURL()
      os.system("gmplayer -prefer-ipv4 -cache 4096 %s"%(url))

   @pyqtSignature("")
   def on_btnAbout_clicked(self):
      QMessageBox.about(self,"About WebTv","""Orange WebTv Standalone application
      
      JJL <BuggerOne@gmail.com>
      http://kubuntu.free.fr/
      Licence: GPLv2""")

if __name__ == "__main__":
   # create window
   app = QApplication(sys.argv)
   window = MonAppli(None)
   window.show()
   sys.exit(app.exec_())
