#!/usr/bin/python

# $1 : channel

import cookielib,urllib2,urllib

POST={'callCount': 1,
'page':'/home.do?null',
'httpSessionId':'',
'scriptSessionId':'17B5FB7248584200A62B28FA446258E5840',
'c0-scriptName':'ChannelService',
'c0-methodName':'getChannelUrlToPlayLowQuality',
'c0-id':0,
'c0-param0':'number:2',
'batchId':2}
URL="http://webtv.guidetv.orange.fr/dwr/call/plaincall/ChannelService.getChannelUrlToPlayLowQuality.dwr"

USERAGENT="Mozilla/5.0 (X11; U; Linux i686; fr; rv:1.8.1.13) Gecko/20080325 Ubuntu/7.10 (gutsy) Firefox/2.0.0.13"

class webtv:
   
   def __init__(self,cookies="cookies.txt",post="post.txt"):
      self.cookies=cookies
      self.post=post
      self.cj = cookielib.CookieJar()
      self.opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(self.cj))
      urllib2.install_opener(self.opener)
      self.post = POST

   def getSession (self):
      """Get session key"""
      req = urllib2.Request(URL)
      req.add_header ("Content-Type","text/plain")
      req.add_header ("User-Agent",USERAGENT)
      a = urllib2.urlopen(req)
      for c in self.cj:
         if c.name == "JSESSIONID":
            self.post['httpSessionId'] = c.value
      
   def getURL (self):
      req = urllib2.Request(URL)
      req.add_header ("Content-Type","text/plain")
      req.add_header ("User-Agent",USERAGENT)
      req.add_data (urllib.urlencode(self.post))
      ans = urllib2.urlopen(req).read()
      return ans[ans.find("mms://"):ans.rfind("KEY")+3]
      
   def setStream(self,id):
      """Set stream id in POST request"""
      self.post['c0-param0']='number:%s'%(id)
      
   def dumpCookies(self):
      for c in self.cj:
         print c.name, ": ", c.value
         

if __name__ == "__main__":
   import sys
   if len(sys.argv) != 2:
      print "usage:",sys.argv[0],"ChannelId"
      sys.exit(1)
   tv = webtv()
   tv.getSession()
   #~ tv.dumpCookies()
   tv.setStream(sys.argv[1])
   a = tv.getURL()
   print a
   
